module AtomicEval 

where

import List 
import Formula

-- tests if a multiset is a subset of another multiset
-- multisets are represented as _ordered_ lists
isMSubset [] _ = True
isMSubset (a:_) [] = False
isMSubset (a:as) (b:bs)
	| (a==b) = isMSubset as bs
	| otherwise = isMSubset (a:as) bs

evalLuk :: RSeq -> Bool
evalLuk (RSeq fsl Leq fsr)
	| (ofsl == ofsr) = True
	| otherwise      = evalLuk (RSeq ofsl Lt ofsr)
	where ofsl = sort fsl
	      ofsr = sort fsr
	
evalLuk (RSeq fsl Lt fsr)
	| (ofsl == ofsr) = False
	| otherwise = isMSubset ofsr ofsl
	where ofsl = sort fsl
	      ofsr = sort fsr

evalHSeq :: (RSeq -> Bool) -> HSeq -> Bool
evalHSeq f (HSeq rs) = or $ map f rs
	

getLeaves :: Derivation -> [HSeq]
getLeaves (Leaf h) = [h]
getLeaves (Der _ _ ds) = concat $ map getLeaves ds

evalDerivation :: (RSeq -> Bool) -> Derivation  -> Bool
evalDerivation f = (and . map (evalHSeq f). getLeaves)
