module GilesOutput where 

import Formula;


instance Show Formula where
	show Falsum = "0"
	show (SAnd f1 f2) = "(" ++ show f1 ++ "&" ++ show f2 ++ ")"
	show (And f1 f2) = "(" ++ show f1 ++ "/\\\\" ++ show f2 ++ ")"
	show (Or f1 f2) = "(" ++ show f1 ++ "\\\\/" ++ show f2 ++ ")"
	show (Impl f1 f2) = "(" ++ show f1 ++ "->" ++ show f2 ++ ")"
	show (Atom c) = [c]


instance Show State where
	show (St y m) = "["++fs2s y++ " | "++ fs2s m++"]"
		where
		fs2s fs = myTail $ foldl (++) "" $ map ("," ++) $  map show fs
		myTail [] = []
		myTail l = tail l

instance Show GTree where
	show gt  = "digraph Game {" ++ gt2d gt ++ "}"
		where 
		gt2d l@(GLeaf t) = "\"" ++ root2s l++"\";\n"
		gt2d n@(GNode t ((c1,l1):[])) = "\"" ++ root2s n ++"\" -> \"" ++ root2s c1 ++ "\"[label=\""++l1++"\"];\n" ++ gt2d c1
		gt2d n@(GNode t ((c1,l1):gts)) = "\"" ++ root2s n ++"\" -> \"" ++ root2s c1 ++ "\"[label=\""++l1++"\"];\n" ++ gt2d (GNode t gts) ++ gt2d c1
		root2s (GLeaf s) = show s ++ "\\n"
		root2s (GNode s _) = show  s ++ "\\n"

